
##########################  Data ###########################################


n=100  # No of Obsevbations #

x_3= rnorm(n, 2,0.1) # Covariate #

x_2= rgamma(n, 5, 0.1) # Covariate #

x_0= rgamma(n, 5, 0.1) # Instrumental variable #


##  Latent Covariate ##

b_0=10

b_1=-2

b_2=3




sigma_2=4

U=rnorm(n, b_0 + b_1*x_2 +  b_2*x_0 , (sigma_2)^0.5) 


x_1=ifelse(U<=0,0,U) # 0-Infalted Covariate #





bb_0=5

bb_1=-1.5




sigma_3=5

V=rnorm(n, bb_0 + bb_1*x_3, (sigma_3)^0.5) 


x_4=ifelse(V<=0,0,V) # 0-Infalted Covariate #



##  Latent Response ##


beta_0=150

beta_1=-1.5

beta_2=1

beta_3=0.5

beta_4=10


sigma_1=1


Z=rnorm(n, beta_0 + beta_1*U + beta_2*x_2+ beta_3*x_3+beta_4*V, (sigma_1)^0.5)



Y=ifelse(Z<0,0,Z) # 0-Infalted Response #


Data=data.frame(Y,x_1,x_2,x_3,x_4,x_0)

write.table(Data, sep = " ", file = "C://Users//Welcome//Desktop//Data.txt")
#######  Import Data ############


Data=read.table(sep = " ", file = "C://Users//Welcome//Desktop//Data.txt")


n=length(Data$Y)


############  Estimation of the distribution of latent covariate ############


r=500  # No of samples #


        mat <- matrix(NA,ncol = r, nrow = 14)

        U <- rnorm(n,0,1)
        V <- rnorm(n,0,1)
        Z<- rep(0, n)
        b <- rep(0, 3)
        bb <- rep(0, 2)
        beta <- rep(0, 5)
        L=0
        s_1=1
        s_2=1 
        s_3=1



        mat[,1] <- c(beta,b,bb,s_1,s_2,s_3,L)


        for (i in 2:r) {




X=cbind(rep(1,n), U, Data$x_2, Data$x_3,V)

beta=mvrnorm(1, solve(t(X)%*%X)%*%(t(X)%*%Z),  solve(t(X)%*%X) )

Z <- rtnorm(n, mean=X%*%beta, sd=(s_1)^0.5, lower=-Inf, upper=0)

Z=ifelse(Data$Y>0,Data$Y,Z)

s_1=rigamma(1, alpha= (n/2 -1) , beta= (t(Z-X%*%beta)%*%(Z-X%*%beta))/2 )



XX=cbind(rep(1,n), Data$x_2,  Data$x_0)

b=mvrnorm(1, solve(t(XX)%*%XX)%*%(t(XX)%*%U),  solve(t(XX)%*%XX) )

MM=( (XX%*%b)/s_2 + (beta[2]/s_1)*(Z-(beta[1]+beta[3]*Data$x_2+beta[4]*Data$x_3+beta[5]*V) ))/(1/s_2 + (beta[2]^2)/s_1   )

U <- rtnorm(n, mean=MM  , sd=(1/(1/s_2+ ( (beta[2])^2)/s_1   ))^0.5, lower=-Inf, upper=0)

U=ifelse(Data$x_1>0,Data$x_1,U)


s_2=rigamma(1, alpha= (n/2 -1) , beta= (t(U-XX%*%b)%*%(U-XX%*%b))/2 )



XXX=cbind(rep(1,n), Data$x_3)

bb=mvrnorm(1, solve(t(XXX)%*%XXX)%*%(t(XXX)%*%V),  solve(t(XXX)%*%XXX) )

MMM=( (XXX%*%bb)/s_3 + (beta[5]/s_1)*(Z-(beta[1]+beta[2]*U+beta[3]*Data$x_2+beta[4]*Data$x_3) ))/(1/s_3 + (beta[5]^2)/s_1 )

V <- rtnorm(n, mean=MMM  , sd=(1/( 1/s_3 + ((beta[5])^2))/s_1   )^0.5, lower=-Inf, upper=0)

V=ifelse(Data$x_4>0,Data$x_4,V)


s_3=rigamma(1, alpha= (n/2 -1) , beta= (t(V-XXX%*%bb)%*%(V-XXX%*%bb))/2 )


L= -2*sum(ifelse(Data$Y==0,log(pnorm(0,X%*%beta, (s_1)^0.5)),log(dnorm(Data$Y,X%*%beta,(s_1)^0.5)) ))



                mat[,i ] <- c(beta,b,bb,s_1,s_2,s_3,L)


        }







## Estimate ##


beta_0_cap=mean(mat[1,(r/2):r])

beta_1_cap=mean(mat[2,(r/2):r])

beta_2_cap=mean(mat[3,(r/2):r])

beta_3_cap=mean(mat[4,(r/2):r])

beta_4_cap=mean(mat[5,(r/2):r])


b_0_cap=mean(mat[6,(r/2):r])

b_1_cap=mean(mat[7,(r/2):r])

b_2_cap=mean(mat[8,(r/2):r])

bb_0_cap=mean(mat[9,(r/2):r])

bb_1_cap=mean(mat[10,(r/2):r])

sig_1=mean(mat[11,(r/2):r])

sig_2=mean(mat[12,(r/2):r])

sig_3=mean(mat[13,(r/2):r])




mm1=b_0_cap+b_1_cap*Data$x_2+b_2_cap*Data$x_0

mm2=bb_0_cap+bb_1_cap*Data$x_3
 

Z_cap=beta_0_cap+beta_1_cap*(ifelse(Data$x_1<=0,mm1 + (sig_2^0.5)*(-dnorm(-mm1/(sig_2^0.5),0,1)/pnorm(-mm1/(sig_2^0.5),0,1)),Data$x_1))+beta_2_cap*Data$x_2+beta_3_cap*Data$x_3+beta_4_cap*(ifelse(Data$x_4<=0,mm2 + (sig_3^0.5)*(-dnorm(-mm2/(sig_3^0.5),0,1)/pnorm(-mm2/(sig_3^0.5),0,1)),Data$x_4))


